
package de.ivu.elect.presentation.wahlvorschlag.action;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.dokumente.action.DokumentErzeugenActionEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlag.dokumente.WahlvorschlagDokumentErzeugenView;

public class ListeWahlvorschlagDokumentErzeugenAction extends AbstractListeAction implements DokumentErzeugenActionEntry {

  private static final long serialVersionUID = 1L;

  @View
  @Inject
  private transient WahlvorschlagDokumentErzeugenView wahlvorschlagDokumentErzeugenView;

  public ListeWahlvorschlagDokumentErzeugenAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return wahlvorschlagDokumentErzeugenView.getUseCasePermission();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal(Liste liste) {
    return false; // Cf. DirektkandidaturWahlvorschlagDokumentErzeugenAction!
  }

  @Override
  protected String doIt(Liste liste) {
    return wahlvorschlagDokumentErzeugenView.initWahlvorschlag(liste);
  }

  @Override
  public String getLabelKey() {
    return "liste.wahlvorschlag.dokument.erzeugen.action";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDocument();
  }
}
